/// <reference types="node" />
import { EventEmitter } from 'events';
import { Device, HID } from 'node-hid';
export declare class U2FHIDDevice extends EventEmitter {
    static open(device: Device): Promise<U2FHIDDevice>;
    protocolVersion: number;
    deviceVersion: number[];
    caps: {
        wink?: boolean;
    };
    closed: boolean;
    device: HID;
    private _channelId;
    private _packetBuf;
    private _transactionQueue;
    private _curTransaction;
    constructor(deviceInfo: Device);
    init(forSure?: boolean): Promise<this>;
    command(command: number, data?: Buffer): Promise<Buffer>;
    close(): void;
    ping(data: Buffer): Promise<Buffer>;
    wink(): Promise<Buffer | undefined>;
    msg(data: Buffer): Promise<Buffer>;
    private _onError;
    private _onData;
    private _executeNextTransaction;
    private _sendCommand;
}
