"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var events_1 = require("events");
var defer_1 = require("./defer");
var u2f_device_1 = require("./u2f-device");
var u2f_hid_device_1 = require("./u2f-hid-device");
var util_1 = require("./util");
var DEVICE_CACHE_TIME = 100;
var U2FHost = /** @class */ (function (_super) {
    __extends(U2FHost, _super);
    function U2FHost(_a) {
        var detectFn = _a.detectFn;
        var _this = _super.call(this) || this;
        _this.waitForDevicesPollInterval = 200;
        _this.waitForDevicesTimeout = 10 * 1000;
        _this.userPresenceTimeout = 10 * 1000;
        _this.devices = [];
        _this._lastSync = 0;
        _this.detectFn = detectFn;
        _this.syncDevices();
        return _this;
    }
    U2FHost.discover = function (detectFn) {
        return new U2FHost({ detectFn: detectFn });
    };
    U2FHost.prototype.syncDevices = function () {
        this.devices = util_1.enumerateDevices(this.detectFn);
        this._lastSync = Date.now();
    };
    U2FHost.prototype.register = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._doWithDevices(function (d) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, d.register(req)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    U2FHost.prototype.authenticate = function (req) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._doWithDevices(function (d) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, d.authenticate(req)];
                                    case 1: return [2 /*return*/, _a.sent()];
                                }
                            });
                        }); })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    U2FHost.prototype._getDevices = function () {
        var currentTs = Date.now();
        if (this.devices && currentTs - this._lastSync < DEVICE_CACHE_TIME) {
            return this.devices;
        }
        this.syncDevices();
        return this.devices;
    };
    U2FHost.prototype._doWithDevices = function (fn) {
        return __awaiter(this, void 0, void 0, function () {
            var devices, eventEmitted;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._waitForDevices()];
                    case 1:
                        devices = _a.sent();
                        eventEmitted = false;
                        return [2 /*return*/, Promise.race(devices.map(function (device) { return __awaiter(_this, void 0, void 0, function () {
                                var hidDevice, u2fDevice, e_1;
                                var _this = this;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, u2f_hid_device_1.U2FHIDDevice.open(device)];
                                        case 1:
                                            hidDevice = _a.sent();
                                            u2fDevice = new u2f_device_1.U2FDevice(hidDevice);
                                            u2fDevice.interactionTimeout = this.userPresenceTimeout;
                                            u2fDevice.on('user-presence-required', function () {
                                                if (!eventEmitted) {
                                                    _this.emit('user-presence-required');
                                                    eventEmitted = true;
                                                }
                                            });
                                            _a.label = 2;
                                        case 2:
                                            _a.trys.push([2, 4, 5, 6]);
                                            return [4 /*yield*/, fn(u2fDevice)];
                                        case 3: return [2 /*return*/, _a.sent()];
                                        case 4:
                                            e_1 = _a.sent();
                                            // throw e;
                                            console.error(e_1);
                                            return [3 /*break*/, 6];
                                        case 5:
                                            u2fDevice.close();
                                            return [7 /*endfinally*/];
                                        case 6: return [2 /*return*/];
                                    }
                                });
                            }); }))];
                }
            });
        });
    };
    U2FHost.prototype._waitForDevices = function () {
        return __awaiter(this, void 0, void 0, function () {
            var deferred, startTime, eventEmitted, poll;
            var _this = this;
            return __generator(this, function (_a) {
                deferred = new defer_1.default();
                startTime = Date.now();
                eventEmitted = false;
                poll = function () {
                    var devices = _this._getDevices();
                    if (devices.length > 0) {
                        deferred.resolve(devices);
                        return;
                    }
                    if (Date.now() - startTime > _this.waitForDevicesTimeout) {
                        throw new Error('Timed out waiting for U2F device');
                    }
                    if (!eventEmitted) {
                        _this.emit('waiting-for-device');
                        eventEmitted = true;
                    }
                    setTimeout(poll, _this.waitForDevicesPollInterval);
                };
                poll();
                return [2 /*return*/, deferred.promise];
            });
        });
    };
    U2FHost.protocolVersion = 'U2F_V2';
    return U2FHost;
}(events_1.EventEmitter));
exports.U2FHost = U2FHost;
//# sourceMappingURL=u2f-host.js.map